#ifndef CETONCHANNEL_H
#define CETONCHANNEL_H

// Qt headers
#include <QString>

// MythTV headers
#include "dtvchannel.h"

class CetonChannel;
class CetonStreamHandler;
class ProgramMapTable;

class CetonChannel : public DTVChannel
{
    friend class CetonSignalMonitor;
    friend class CetonRecorder;

  public:
    CetonChannel(TVRec *parent, const QString &device);
    ~CetonChannel(void);

    bool Open(void);
    void Close(void);
    bool EnterPowerSavingMode(void);

    bool Init(QString &inputname, QString &startchannel, bool setchan);

    // Sets
    bool SetChannelByString(const QString &chan);

    // Gets
    bool IsOpen(void) const;
    QString GetDevice(void) const { return _device_id; }
    virtual vector<DTVTunerType> GetTunerTypes(void) const { return _tuner_types; }

    // ATSC/DVB scanning/tuning stuff
    bool TuneMultiplex(uint mplexid, QString inputname);
    bool Tune(const DTVMultiplex &tuning, QString inputname);

  private:
    bool Tune(uint frequency, QString inputname,
              QString modulation, uint program, QString si_std);

  private:
    QString               _device_id;
    CetonStreamHandler    *_stream_handler;
    vector<DTVTunerType>  _tuner_types;

    mutable QMutex  _lock;
    mutable QMutex  tune_lock;
    mutable QMutex  hw_lock;
};

#endif
