#ifndef CETONRTSP_H
#define CETONRTSP_H

#include <QObject>
#include <QHash>
#include <QString>
#include <QMutex>

class CetonRTSP : public QObject
{
    Q_OBJECT
public:
    explicit CetonRTSP(const QString& ip, uint tuner, ushort port, QObject *parent = 0);

    bool doOptions(QStringList& options);
    bool doDescribe();
    bool doSetup(ushort clientPort1, ushort clientPort2);
    bool doPlay();
    bool doTeardown();

protected:
    bool processRequest(const QString& method, const QStringList* headers = NULL);

private:
    QString     _ip;
    ushort      _port;
    uint        _tuner;
    uint        _sequenceNumber;
    uint        _sessionNumber;
    QString     _requestUrl;

    int                     _responseCode;
    QString                 _responseMessage;
    QHash<QString,QString>  _responseHeaders;
    QByteArray              _responseContent;

    static QMutex _rtspMutex;

};

#endif // CETONRTSP_H
