// -*- Mode: c++ -*-

#ifndef CETONSIGNALMONITOR_H
#define CETONSIGNALMONITOR_H

#include <QMap>

#include "dtvsignalmonitor.h"

class CetonChannel;
class CetonStreamHandler;

typedef QMap<uint,int> FilterMap;

class CetonSignalMonitor: public DTVSignalMonitor
{
  public:
    CetonSignalMonitor(int db_cardnum, CetonChannel* _channel,
                      uint64_t _flags = 0);
    virtual ~CetonSignalMonitor();

    void Stop(void);

  protected:
    CetonSignalMonitor(void);
    CetonSignalMonitor(const CetonSignalMonitor&);

    virtual void UpdateValues(void);
    CetonChannel *GetCetonChannel(void);

  protected:
    bool               streamHandlerStarted;
    CetonStreamHandler *streamHandler;
};

#endif // CETONSIGNALMONITOR_H
